use actix_web::{dev::ServiceRequest, HttpRequest};
pub use http_signature_normalization::verify::{
    Algorithm, DeprecatedAlgorithm, ParseSignatureError, ParsedHeader, Unvalidated, Unverified,
    ValidateError,
};

use crate::{Config, Verify, VerifyError};

impl Verify for HttpRequest {
    fn begin_verify(&self, config: &Config) -> Result<Unverified, VerifyError> {
        config.begin_verify(
            self.method(),
            self.uri().path_and_query(),
            self.headers().clone(),
        )
    }
}

impl Verify for ServiceRequest {
    fn begin_verify(&self, config: &Config) -> Result<Unverified, VerifyError> {
        config.begin_verify(
            self.method(),
            self.uri().path_and_query(),
            self.headers().clone(),
        )
    }
}
